//
//    CalcEm - Calculator Emulator
//    Copyright (C) 1998  David Eriksson - david@2goodsoft.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//////////////////////////////////////////////////////////////////////////////////
// Project Name: [ Calculator Emulator (CalcEm) ]
// Source File:  [ Hex edit class header ]
// Author:       [ David Eriksson - david@2goodsoft.com ]
// Revision:     [ 0.4 ]
//////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_HEXEDIT_H__4E2DAF21_C80A_11D1_BD69_0000C053B4FA__INCLUDED_)
#define AFX_HEXEDIT_H__4E2DAF21_C80A_11D1_BD69_0000C053B4FA__INCLUDED_

#include "Scroltip.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// HexEdit.h : header file
//

#define HEXEDIT_CLASSNAME _T("CalcEm_HexEdit")

/////////////////////////////////////////////////////////////////////////////
// CHexEdit window

#define modeChar	0
#define modeHex		1
#define modeHexEdit	(modeHex | 2)

class CHexEdit : public CWnd
{
// Construction
public:
	CHexEdit();

	DECLARE_DYNCREATE(CHexEdit)

// Attributes
public:
	CFont m_font;

	unsigned m_Mode;
	unsigned m_cLines;
	unsigned m_cLinesPerPage;
	unsigned m_CharHeight;
	unsigned m_cBuffer;
	PBYTE m_pBuffer;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHexEdit)
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdateCaretPos();
	void SetCurrentByte(BYTE data);
	CPoint m_DataMaxPoint;
	CPoint m_DataPoint;
	LONG m_CharWidth;
	CMRCScrollTip m_ScrollTip;
	BOOL RegisterWindowClass();
	POINT m_CaretPos;
	void GotoOffset(unsigned offs);
//	virtual BOOL Create(CWnd* pParentWnd, const RECT& rect, DWORD dwStyle = WS_CHILD|WS_VISIBLE, UINT nID=0xDEDE);
    BOOL Create(const RECT& rect, CWnd* parent, UINT nID,
                    DWORD dwStyle = WS_CHILD | /*WS_BORDER | WS_TABSTOP |*/ WS_VISIBLE | WS_CLIPSIBLINGS | WS_OVERLAPPED);
	virtual ~CHexEdit();

	// Generated message map functions
protected:
	//{{AFX_MSG(CHexEdit)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HEXEDIT_H__4E2DAF21_C80A_11D1_BD69_0000C053B4FA__INCLUDED_)
