//
//    CalcEm - Calculator Emulator
//    Copyright (C) 1998  David Eriksson - david@2goodsoft.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//////////////////////////////////////////////////////////////////////////////////
// Project Name: [ Calculator Emulator (CalcEm) ]
// Source File:  [ Link port helper class header ]
// Author:       [ David Eriksson - david@2goodsoft.com ]
// Revision:     [ 0.2 ]
//////////////////////////////////////////////////////////////////////////////////
// LinkPort.h: interface for the CLinkPort class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LINKPORT_H__ECC55A01_D88D_11D1_BD69_0000C053B4FA__INCLUDED_)
#define AFX_LINKPORT_H__ECC55A01_D88D_11D1_BD69_0000C053B4FA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef enum 
{
	Inactive, 
	Receive, Send,
	ExpectReceive, ExpectSend,
	Cancel
} LinkDirection;

class CLinkPort  
{
public:
	CLinkPort();
	virtual ~CLinkPort();

public:
	// Direction
	LinkDirection volatile m_Dir;

	// Buffer level
	unsigned char * m_pBuffer;
	unsigned m_cBuffer;
	unsigned m_ndxBuffer;

	// Byte level
	unsigned char m_CurrentByte;
	unsigned char m_BitsLeft;

	// In/Out level
	unsigned char m_StepsLeft;

public:
	virtual void LinkInput();
	virtual void LinkOutput();
};

#endif // !defined(AFX_LINKPORT_H__ECC55A01_D88D_11D1_BD69_0000C053B4FA__INCLUDED_)
