//
//    CalcEm - Calculator Emulator
//    Copyright (C) 1998  David Eriksson - david@2goodsoft.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//////////////////////////////////////////////////////////////////////////////////
// Project Name: [ Calculator Emulator (CalcEm) ]
// Source File:  [ Main window header ]
// Author:       [ David Eriksson - david@2goodsoft.com ]
// Revision:     [ 0.5 ]
//////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_MAINWND_H__E6EA1181_D06C_11D1_BD69_0000C053B4FA__INCLUDED_)
#define AFX_MAINWND_H__E6EA1181_D06C_11D1_BD69_0000C053B4FA__INCLUDED_

#include "MemoryDbgWnd.h"	// Added by ClassView
#include "RegistersDbgWnd.h"	// Added by ClassView
#include "asmwnd.h"	// Added by ClassView
#include "ScreenWnd.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// MainWnd.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMainWnd window

class CMainWnd : public CWnd
{
// Construction
public:
	CMainWnd();

// Attributes
public:
	static UINT s_Refresh;

// Operations
public:
	void AdjustDlgRect(LPRECT pRect);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainWnd)
	public:
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	CProgressCtrl m_Progress;
	CScreenWnd m_ScreenWnd;
	unsigned m_StatusHeight;
	CAsmWnd m_AsmDbgWnd;
	HACCEL m_hAccel;
	bool m_RefreshOnInt;
	CRegistersDbgWnd m_RegsDbgWnd;
	CString m_strRamFile;
	CString m_strRomFile;
	CMemoryDbgWnd m_MemoryDbgWnd;
	virtual BOOL Create();
	virtual ~CMainWnd();
	CStatusBarCtrl m_StatusBar;

	// Generated message map functions
protected:
	//{{AFX_MSG(CMainWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnCalcScreendump();
	afx_msg void OnCalcStart();
	afx_msg void OnCalcStop();
	afx_msg void OnDbgwinMemory();
	afx_msg void OnDbgwinRegs();
	afx_msg void OnDestroy();
	afx_msg void OnFileEmu83Load();
	afx_msg void OnFileEmu83Save();
	afx_msg void OnFileExit();
	afx_msg void OnFileOpenrom();
	afx_msg void OnFileOpenTi8xemu();
	afx_msg void OnFileSaveTi8xemu();
	afx_msg void OnFileSaveTi8xemu2();
	afx_msg void OnFileSendtoemulator();
	afx_msg void OnHelpAbout();
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnOptDisprefrImmed();
	afx_msg void OnOptDisprefrOnint();
	afx_msg void OnPaint();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg void OnUpdateFileEmu83Save(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSendtoemulator(CCmdUI* pCmdUI);
	afx_msg void OnDbgwinAsm();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	afx_msg void EnableIfRunning(CCmdUI* pCmdUI);
	afx_msg void DisableIfRunning(CCmdUI* pCmdUI);
	afx_msg void OnEnterMenuLoop( BOOL bIsTrackPopupMenu );
	afx_msg void OnExitMenuLoop( BOOL bIsTrackPopupMenu );
	afx_msg BOOL OnOpenRecentFile(UINT nID);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINWND_H__E6EA1181_D06C_11D1_BD69_0000C053B4FA__INCLUDED_)
