//
//    CalcEm - Calculator Emulator
//    Copyright (C) 1998  David Eriksson - david@2goodsoft.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//////////////////////////////////////////////////////////////////////////////////
// Project Name: [ Calculator Emulator (CalcEm) ]
// Source File:  [ Memory view implementation ]
// Author:       [ David Eriksson - david@2goodsoft.com ]
// Revision:     [ 0.4 ]
//////////////////////////////////////////////////////////////////////////////////
// MemoryDbgWnd.cpp : implementation file
//

#include "stdafx.h"
#include "calcem.h"
#include "MemoryDbgWnd.h"
#include "Calculator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMemoryDbgWnd

CMemoryDbgWnd::CMemoryDbgWnd()
{
}

CMemoryDbgWnd::~CMemoryDbgWnd()
{
}


BEGIN_MESSAGE_MAP(CMemoryDbgWnd, CFloatWnd)
	//{{AFX_MSG_MAP(CMemoryDbgWnd)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMemoryDbgWnd message handlers

int CMemoryDbgWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFloatWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_HexEdit.m_pBuffer = g_pCalculator->m_pMemory;

	RECT rect;
	GetClientRect(&rect);
	m_HexEdit.Create(rect, this, 0xDE);
	
	return 0;
}

BOOL CMemoryDbgWnd::Create(CWnd * pParentWnd, DWORD dwStyle)
{
	RECT r;
	r.left = AfxGetApp()->GetProfileInt("Memory Window", "Left", 50);
	r.top = AfxGetApp()->GetProfileInt("Memory Window", "Top", 50);
	r.right = AfxGetApp()->GetProfileInt("Memory Window", "Right", 700);
	r.bottom = AfxGetApp()->GetProfileInt("Memory Window", "Bottom", 250);

	return CFloatWnd::Create(
		"Memory",
		r,
		pParentWnd,
		dwStyle | WS_THICKFRAME );
}

void CMemoryDbgWnd::OnSize(UINT nType, int cx, int cy) 
{
	CFloatWnd::OnSize(nType, cx, cy);
	
	RECT rect;
	GetClientRect(&rect);
	m_HexEdit.MoveWindow(&rect);
}

void CMemoryDbgWnd::OnSetFocus(CWnd* pOldWnd) 
{
	CFloatWnd::OnSetFocus(pOldWnd);
	
	// Why do I have to do this manually??
	m_HexEdit.SetFocus();
}

void CMemoryDbgWnd::OnDestroy() 
{
	CFloatWnd::OnDestroy();
	
	RECT r;
	GetWindowRect(&r);
	AfxGetApp()->WriteProfileInt("Memory Window", "Left", r.left);
	AfxGetApp()->WriteProfileInt("Memory Window", "Top", r.top);
	AfxGetApp()->WriteProfileInt("Memory Window", "Right", r.right);
	AfxGetApp()->WriteProfileInt("Memory Window", "Bottom", r.bottom);
}
