//
//    CalcEm - Calculator Emulator
//    Copyright (C) 1998  David Eriksson - david@2goodsoft.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//////////////////////////////////////////////////////////////////////////////////
// Project Name: [ Calculator Emulator (CalcEm) ]
// Source File:  [ CMiniCalculator class header ]
// Author:       [ David Eriksson - david@2goodsoft.com ]
// Revision:     [ 0.3 ]
//////////////////////////////////////////////////////////////////////
// MiniCalculator.h: interface for the CMiniCalculator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MINICALCULATOR_H__53F276E1_D564_11D1_BD69_0000C053B4FA__INCLUDED_)
#define AFX_MINICALCULATOR_H__53F276E1_D564_11D1_BD69_0000C053B4FA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Calculator.h"

class CMiniCalculator : public CCalculator  
{
public:
	CMiniCalculator();
	virtual ~CMiniCalculator();

public:
	unsigned char m_KeyboardMask;
	unsigned char m_MaskON;
	unsigned char m_ONKeyDown;
	unsigned char m_DispX, m_DispY;
	unsigned char m_DisplayMode, m_DisplayMove;
	bool m_CursorMoved;
//	bool m_DisplayUpdated;

public:
//	virtual bool LoadTi8xEmuRAM( const char * pszFile );
//	virtual bool StoreTi8xEmuRAM( const char * pszFile, unsigned nVersion = 0x0201 );

protected:
	virtual unsigned char DisplayInput();
	virtual void DisplayOutput( unsigned char Data );
	virtual void DisplayControl( unsigned char Cmd );

	// Unsorted
public:
	virtual bool Reset();
};

#endif // !defined(AFX_MINICALCULATOR_H__53F276E1_D564_11D1_BD69_0000C053B4FA__INCLUDED_)
