//
//    CalcEm - Calculator Emulator
//    Copyright (C) 1998  David Eriksson - david@2goodsoft.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//////////////////////////////////////////////////////////////////////////////////
// Project Name: [ Calculator Emulator (CalcEm) ]
// Source File:  [ Registers window implementation ]
// Author:       [ David Eriksson - david@2goodsoft.com ]
// Revision:     [ 0.5 ]
//////////////////////////////////////////////////////////////////////////////////
// RegistersDbgWnd.cpp : implementation file
//

#include "stdafx.h"
#include "calcem.h"
#include "RegistersDbgWnd.h"
#include "Calculator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegistersDbgWnd

CRegistersDbgWnd::CRegistersDbgWnd()
{
}

CRegistersDbgWnd::~CRegistersDbgWnd()
{
}


BEGIN_MESSAGE_MAP(CRegistersDbgWnd, CFloatWnd)
	//{{AFX_MSG_MAP(CRegistersDbgWnd)
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_WM_ACTIVATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CRegistersDbgWnd message handlers

void CRegistersDbgWnd::OnDestroy() 
{
	CFloatWnd::OnDestroy();
	
	RECT r;
	GetWindowRect(&r);
	AfxGetApp()->WriteProfileInt("Registers Window", "Left", r.left);
	AfxGetApp()->WriteProfileInt("Registers Window", "Top", r.top);
}

int CRegistersDbgWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFloatWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_RegsDlg.Create( CRegsDlg::IDD, this );

	RECT rect;
	GetWindowRect(&rect);

	// Find out width/height of borders etc
	LONG ExtraW = 2 * GetSystemMetrics(SM_CXDLGFRAME);
	LONG ExtraH = 2 * GetSystemMetrics(SM_CYDLGFRAME) + GetSystemMetrics(SM_CYSMCAPTION);

	CRect dlgRect;
	m_RegsDlg.GetWindowRect(&dlgRect);

	// Set possible width and height
	rect.right = rect.left + ExtraW + dlgRect.Width();
	rect.bottom = rect.top + ExtraH + dlgRect.Height();

	MoveWindow(&rect, FALSE);

	return 0;
}

BOOL CRegistersDbgWnd::Create(CWnd * pParent, DWORD dwStyle)
{
	dwStyle &= ~WS_THICKFRAME;

	RECT r;
	r.left = AfxGetApp()->GetProfileInt("Registers Window", "Left", 50);
	r.top = AfxGetApp()->GetProfileInt("Registers Window", "Top", 50);
	r.right = r.left + 100;	// dummy values
	r.bottom = r.top + 100;	// dummy values

	return CFloatWnd::Create(
			"Registers and information",
			r,
			pParent,
			dwStyle | WS_DLGFRAME);
}

void CRegistersDbgWnd::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CFloatWnd::OnActivate(nState, pWndOther, bMinimized);
	
	if( nState == WA_INACTIVE )
	{
		if( !m_RegsDlg.Store() )
			; //SetFocus();
	}
	else
		m_RegsDlg.Load();
}
