//
//    CalcEm - Calculator Emulator
//    Copyright (C) 1998  David Eriksson - david@2goodsoft.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//////////////////////////////////////////////////////////////////////////////////
// Project Name: [ Calculator Emulator (CalcEm) ]
// Source File:  [ Registers dialog implementation ]
// Author:       [ David Eriksson - david@2goodsoft.com ]
// Revision:     [ 0.4 ]
//////////////////////////////////////////////////////////////////////////////////
// RegsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "calcem.h"
#include "RegsDlg.h"
#include "Calculator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegsDlg dialog


CRegsDlg::CRegsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CRegsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRegsDlg, CDialog)
	//{{AFX_MSG_MAP(CRegsDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_ACTIVATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegsDlg message handlers

BOOL CRegsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	for(UINT id = IDC_EDIT1; id <= IDC_EDIT12; id++)
	{
		SendDlgItemMessage(id, EM_LIMITTEXT, 4);
	}

	SendDlgItemMessage(IDC_IM, EM_LIMITTEXT, 1);
	SendDlgItemMessage(IDC_I, EM_LIMITTEXT, 2);
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRegsDlg::OnButton1() 
{
	Load();
}

void CRegsDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	TRACE("CRegsDlg::OnActivate(%i)\n", nState);

	CDialog::OnActivate(nState, pWndOther, bMinimized);
}

void CRegsDlg::Load()
{
	char szTemp[5];

	unsigned short * pRegs = (unsigned short *)g_pCalculator->GetRegs();
	int i = 0;
	
	for(UINT id = IDC_EDIT1; id <= IDC_EDIT12; id++)
	{
		sprintf(szTemp, "%04X", pRegs[i++]);
		// ltoa(pRegs[i++], szTemp, 16);
		SendDlgItemMessage(id, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)szTemp );
	}

	ltoa(g_pCalculator->m_RomPageNo, szTemp, 16);
	SendDlgItemMessage(IDC_ROMPAGE, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)szTemp );

	ltoa((g_pCalculator->m_Regs.IFF >> 1) & 3, szTemp, 16);
	SendDlgItemMessage(IDC_IM, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)szTemp );

	sprintf(szTemp, "%02X", g_pCalculator->m_Regs.I);
	//ltoa(g_pCalculator->m_Regs.I, szTemp, 16);
	SendDlgItemMessage(IDC_I, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)szTemp );
}

bool CRegsDlg::Store()
{
	char szTemp[5];
	char * dummy;
	unsigned char temp;

	reg Regs = g_pCalculator->m_Regs;

	try
	{
		// Interrupt mode
		SendDlgItemMessage(IDC_IM, WM_GETTEXT, 5, (LPARAM)(LPCTSTR)szTemp );
		temp = (unsigned char)strtol(szTemp, &dummy, 16);
		if( *dummy || temp < 0 || temp > 2 )
			throw (UINT)IDC_IM;

		Regs.IFF = (Regs.IFF & ~6) | (temp << 1);

		// Interrupt vector
		SendDlgItemMessage(IDC_I, WM_GETTEXT, 5, (LPARAM)(LPCTSTR)szTemp );
		Regs.I = (unsigned char)strtol(szTemp, &dummy, 16);
		if( *dummy )
			throw (UINT)IDC_I;

		int i = 0;
		unsigned short * pRegs = (unsigned short *)&Regs;

		for(UINT id = IDC_EDIT1; id <= IDC_EDIT12; id++)
		{
			//sprintf(szTemp, "%04X", pRegs[i++]);
			// ltoa(pRegs[i++], szTemp, 16);
			SendDlgItemMessage(id, WM_GETTEXT, 5, (LPARAM)(LPCTSTR)szTemp );

			pRegs[i++] = (unsigned short)strtol(szTemp, &dummy, 16);

			if( *dummy )
				throw id;
		}

		g_pCalculator->SetRegs(Regs);

		return true;
	}
	catch(UINT nID)
	{
		MessageBeep(0xffffffff);
		GetDlgItem(nID)->SetFocus();

		return false;
	}
}
