//
//    CalcEm - Calculator Emulator
//    Copyright (C) 1998  David Eriksson - david@2goodsoft.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//////////////////////////////////////////////////////////////////////////////////
// Project Name: [ Calculator Emulator (CalcEm) ]
// Source File:  [ CTi82 class header ]
// Author:       [ David Eriksson - david@2goodsoft.com ]
// Revision:     [ 0.3 ]
//////////////////////////////////////////////////////////////////////
// Ti82.h: interface for the CTi82 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TI82_H__BAA54422_D2BD_11D1_BD69_0000C053B4FA__INCLUDED_)
#define AFX_TI82_H__BAA54422_D2BD_11D1_BD69_0000C053B4FA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "MiniCalculator.h"

#define PORT_LINK			0
#define PORT_KEYBOARD		1
#define PORT_ROMPAGE		2
#define PORT_STATUS			3
#define PORT_INTCTRL		4
#define PORT_DISPCTRL		0x10
#define PORT_DISPDATA		0x11

class CTi82 : public CMiniCalculator  
{
public:
	CTi82();
	virtual ~CTi82();

	// Attributes
public:

	// Operations
public:
	virtual bool Reset();

	virtual unsigned char Input( unsigned char Port );
	virtual void Output( unsigned char Port, unsigned char Data );
	virtual unsigned short Interrupt();

protected:
	unsigned char KeyboardInput();

	// Unsorted
public:
	virtual bool StoreRAM( const char * pszFile, unsigned nVersion = 0x0201 );
	virtual bool LoadRAM( const char * pszFile );

};

#endif // !defined(AFX_TI82_H__BAA54422_D2BD_11D1_BD69_0000C053B4FA__INCLUDED_)
